//ArcadeOS - Real mode stub
//This installs our BIOS/DOS extensions and then runs 32bit ArcadeOS
//(arc32.exe)
#include <stdlib.h> 
#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <dir.h>
#include <ctype.h>
#include <io.h>
#include <process.h>
#include <stdarg.h>

#include "common.h"
#include "arcmain.h"
#include "biosasm.h"
#include "a8042.h"
#include "genarc.h"

extern int bbset;

static char szCurDir[512];
static int nCurDisk;
unsigned char kOrig[40];
unsigned char kNew[80];
int	remaptype;
int	remapdel;
int start12esc;
int shiftkey;
int coin1;


static char *pVFile[3];
static char *pVPos[3];
static int	nVSize[3];
static int	nVMode[3];

char *pSave;

void storeds(int ds);


void main(int argc,char **argv)
{
	FILE *fredir;
	char inargs[512];

	char *pwork;
	int	bFinished;
	int bDPMICopied;
	static char szTemp[512];
	static char szCom[512];
	static char szEmuFile[128];
	static char szName[256];
	static char szRemap[512];
	static char szShift[128];
	static char buffer[1024];


	char *szWorkFile;
	char *szLine;

	int noremaps;

	int llredir;
	int rsize;
	int i;
	int bEnd;
	int bJukeBox=FALSE;
	int bShift;
	int bNag;
   int SVGA;
	size_t nSave;
	FILE *fSave;


	if(AOSAlready())
	{
		printf("\n\nYou are running in an ArcadeOS DOS shell,\nType:\n\n  exit\n\nto return to ArcadeOS\n");
		return;
	}



	storeds(_DS);


	if(!checkfile("license.txt"))
	{
		printf("ArcadeOS License File Missing\n");
		return;
	}

	SVGA=detectati();

	if(!checkfile("pmwrap.exe"))
	{
		printf("Protected mode Wrapper (pmwrap.exe) missing\n");
		return;
	}

	pSave=malloc(4096);


	unlink("c:\\m$.tmp");
	unlink("c:\\m.tmp");

	notimer();
	resetxmode();

	xredirect("copy arcadeos.bin arc32.exe");

//save the current directory
	getdir();
//install our bios
	repbios();
//install our DOS
	repdos();


//turn off low level redirect for now
	llredirect(0);
//run main ArcadeOS app
//SVGA info
	sprintf(inargs,"arc32.exe %d",SVGA);
//command line args
	if(argc>1)
	{
		for(i=1;i<argc;i++)
		{
			strcat(inargs," ");
			strcat(inargs,argv[i]);
		}

	}
	system(inargs);

	strcpy(szName,"Unknown");

	bEnd=FALSE;

	while(!bEnd)
	{
		nSave=0;
		szLine=malloc(512);
		szWorkFile=malloc(128);
		llredir=0;
		remaptype=0;
		bShift=FALSE;
		*szEmuFile=0;
		bJukeBox=FALSE;
		noremaps=0;
//get the command file from ArcadeOS
		fopenVFile(GET_COMMANDS,"rt");
		if(nVSize[VFILE(GET_COMMANDS)]==0)
			bEnd=1;
		if(!bEnd)
		{
			if(fgetsVFile(buffer,1023,GET_COMMANDS))
				bFinished=0;
			else
				bFinished=1;

         bNag=FALSE;
			while(!bFinished)
			{

				bFinished=bEnd=getline(buffer,COMMAND_END,szLine);

				MORE_LINES
				{
					if(getline(buffer,COMMAND_FCOPY,szLine))
					{
						getfilename(szLine,szEmuFile,szWorkFile);
						fSave=fopen(szEmuFile,"rb");
						if(fSave)
						{
							nSave=fread(pSave,1,4096,fSave);
							fclose(fSave);
							fopenVFile(GET_CONFIG,"rt");
							fSave=fopen(szEmuFile,"wb");
							if(fSave)
							{
								fwrite(pVFile[1],strlen(pVFile[1])+1,1,fSave);
								fclose(fSave);
							}
						}
					}
				}

				MORE_LINES
				{
					if(getline(buffer,COMMAND_GAMENAME,szTemp))
					{
						strcpy(szName,szTemp);
					}

				}

				MORE_LINES
				{
					if(getline(buffer,COMMAND_JUKEBOX,szTemp))
						bJukeBox=TRUE;
				}

				MORE_LINES
				{
					if(getline(buffer,COMMAND_REMAP,szTemp))
					{
						strcpy(szRemap,szTemp);
						addremaps(szTemp,&noremaps);
					}

				}

				MORE_LINES
				{
					if(getline(buffer,COMMAND_SHIFTS,szTemp))
					{
						strcpy(szShift,szTemp);
						bShift=TRUE;
					}

				}

				MORE_LINES
				{
					if(getline(buffer,COMMAND_NAG,szTemp))
						bNag=atoi(szTemp);

				}

				MORE_LINES
					bFinished=getline(buffer,COMMAND_COMMAND,szCom);



				MORE_LINES
				{
					if(fgetsVFile(buffer,1023,GET_COMMANDS))
						bFinished=0;
					else
						bFinished=1;
				}

			}
//special case for command.com, not emu specific, so turn everything off
			if(strstr(szCom,"command.com"))
			{
				bShift=noremaps=start12esc=remaptype=llredir=0;
			}
			if(!bEnd)
			{
				if(*szCom)
				{
//check for file redirect
					pwork=strstr(szCom," > c:\\m.tmp");
					if(pwork)
					{
//there's one there, use lowlevel redirect instead
						*pwork=0;
						openredir();
						llredir=1;

					}
					else
						llredir=0;

					llredirect(0);
					setpmflag(0);
					savekrmp();
					stuffrets();
					setjukebox(bJukeBox);

					if(bJukeBox||!bNag)
					{
						inittimer();
						reptimer();
					}

					pwork=&szCom[strlen(szCom)-1];
					while(isspace(*pwork))
						pwork--;
					pwork++;
					*pwork=0;
					setremaps(kOrig,kNew,noremaps,start12esc);

					if(noremaps||start12esc||bShift)
						setkeyrmp(1,remaptype);
					else
						setkeyrmp(0,0);
					putenv("DOS4G=QUIET");


					free(szLine);
					free(szWorkFile);

					if(remaptype==1||bJukeBox||bShift)
					{
						bDPMICopied=FALSE;
						sprintf(buffer,"copy %c:%s\\pmwrap.exe aoswrap.exe",(nCurDisk+'A'),szCurDir);

						xredirect(buffer);

//check for CWSDPMI
						if(!checkfile("cwsdpmi.exe"))
						{
							sprintf(buffer,"%c:%s\\cwsdpmi.exe",(nCurDisk+'A'),szCurDir);
							if(checkfile(buffer))
							{
								sprintf(buffer,"copy %c:%s\\cwsdpmi.exe",(nCurDisk+'A'),szCurDir);
								xredirect(buffer);
								bDPMICopied=TRUE;
							}
						}

						fopenVFile(GET_WRAP,"wt");
						fprintfVFile(GET_WRAP,"%s\n",szCom);
						if(bJukeBox)
						{
							pmsetwrap();
							setkeyrmp(1,1);
							fprintfVFile(GET_WRAP,"%s\n",COMMAND_JUKEBOX);
						}
						fprintfVFile(GET_WRAP,"%s\n",szRemap);

						if(bShift)
							fprintfVFile(GET_WRAP,"%s\n",szShift);
						else
							fprintfVFile(GET_WRAP,"%s\n",NO_SHIFTS);
						setrmsize(GET_WRAP);

						llredirect(llredir);
						system("aoswrap.exe");
						llredirect(0);
						unlink("aoswrap.exe");

						if(bDPMICopied)
							unlink("cwsdpmi.exe");

					}
					else
					{
						llredirect(llredir);
						system(szCom);
						llredirect(0);
					}
					if(noremaps||start12esc)
						putkrmp();


					setkeyrmp(0,0);
					if(bJukeBox||!bNag)
						puttimer();

					resetxmode();
					llredirect(0);

				}
				if(*szEmuFile)
				{
					if(nSave)
					{
//						fSave=fopen(szEmuFile,"wb");
  //						if(fSave)
	 //					{
		//					fwrite(pSave,1,nSave,fSave);
		  //					fclose(fSave);
			 //			}
					}
				}
//if we used a low level redirect, create a file from it
//so the 32bit portion of AOS can display frame rate/warnings etc.
				if(llredir)
				{
					fredir=fopen("c:\\m.tmp","wt");
					if(fredir)
					{
						pwork=malloc(8196);
						if(pwork)
						{
							rsize=readredir(pwork);
							pwork[rsize]=0;
							fwrite(pwork,1,rsize,fredir);
							free(pwork);
						}
						fclose(fredir);
					}
				}
				menudir();

				if(bJukeBox)
					sprintf(szTemp,"arc32.exe \"~%s\" %d jukebox",szName,SVGA);
				else
					sprintf(szTemp,"arc32.exe \"~%s\" %d",szName,SVGA);

				if(!*szCom)
					unlink("c:\\m.tmp");
				unblockmodes();
				system(szTemp);
			}
		}
	}
//put back the old bios
	putbios();
//put back the old DOS
	putdos();
//and delete anything hanging around
	unlink("arc32.exe");
	free(pSave);

}

int getline(char *szIn,char *szCom,char *szOut)
{
	char	*pWork;
	int	ret=0;
	*szOut=0;
	pWork=strstr(szIn,szCom);
	if(pWork)
	{
		pWork+=strlen(szCom);
		strcpy(szOut,pWork);
		ret=1;
	}
	return ret;

}

void getdir()
{
	char *pTemp;
	pTemp=malloc(512);
 //get the current directory
	nCurDisk=getdisk();
	getcurdir(nCurDisk+1,pTemp);
	if(*pTemp)
		sprintf(szCurDir,"\\%s",pTemp);
	else
		*szCurDir=0;
	free(pTemp);
}

void menudir()
{
//change back to our directory
	setdisk(nCurDisk);
	chdir(szCurDir);
}

void getfilename(char *szLine,char *szEmuFile,char *szWorkFile)
{
	char *pWork;

	*szEmuFile=0;
	*szWorkFile=0;

	pWork=strstr(szLine,"!");
	if(pWork)
	{
		*pWork=0;
		strcpy(szEmuFile,szLine);
		pWork++;
		strcpy(szWorkFile,pWork);
	}

}

//execute redirected command
void xredirect(char *szExec)
{
	static char	szWork[512];
	sprintf(szWork,"%s >%s",szExec,TEMP_FILE);
	system(szWork);
	unlink(TEMP_FILE);
}


void addremaps(char *szIn,int *noremaps)
{
	int ntot,n,idx;
	char *pWork;
	char *pWork2;
	char *pCodes;
	char szWork[64];

	char szWork2[64];
	char szWork3[512];

	/* pWork=getitem(szWork3,szIn,0,511,'}'); 


	start12esc=atoi(pWork);


	pWork=getitem(szWork3,szIn,1,512,'}');
	remaptype=atoi(pWork);


	pWork=getitem(szWork3,szIn,2,512,'}');
	remapdel=atoi(pWork);
	if(remapdel==99&&start12esc)
		start12esc=2;

	pWork=getitem(szWork3,szIn,3,512,'}');
	shiftkey=atoi(pWork);


	pWork=getitem(szWork3,szIn,4,512,'}');
	coin1=atoi(pWork);

	pCodes=getitem(szWork3,szIn,5,512,'}');
	memset(kNew,0,80);
	memset(kOrig,0,40);


	if(!strcmpi(pCodes,NO_REMAPS))
	{
		*noremaps=0;
		return;
	}
	*/
	
//get the number of remaps
	ntot=getitemcount(pCodes,',');
	if(!ntot||ntot>80)
	{
		remaptype=0;
		*noremaps=0;
		return;
	}
	*noremaps=ntot/2;
	idx=0;
//no go through them
	for(n=0;n<ntot;n+=2)
	{
		pWork=getitem(szWork,pCodes,n,16,',');
		kOrig[idx]=(unsigned char)atoi(pWork);
		pWork=getitem(szWork,pCodes,n+1,32,',');
		pWork2=getitem(szWork2,pWork,0,16,'|');
		kNew[idx]=(unsigned char)atoi(pWork2);
		if(getitemcount(pWork,'|')>1)
		{
			pWork=getitem(szWork2,pWork,1,16,'|');
			kNew[idx+40]=(unsigned char)atoi(pWork);
		}
		else
			kNew[idx+40]=0;
		idx++;

	}
}

int checkfile(char *szFName)
{
	FILE *fcheck;
	fcheck=fopen(szFName,"rb");
	if(fcheck)
	{
		fclose(fcheck);
		return TRUE;
	}
	return FALSE;
}
//common functions from 32bit part of AOS
#include "itemfunc.x"

char far *getpminfo(int cmd,int *size)
{
	union REGS regs;

	regs.h.ah = AOS_BIOS_FLAG;
	regs.h.al = cmd;

	int86(0x10, &regs, &regs);

	*size=regs.x.cx;

	return MK_FP(regs.x.bx,regs.x.dx);

}

void setrmsize(int cmd)
{
	union REGS regs;
	int size;

	size=strlen(pVFile[VFILE(cmd)]);

	regs.h.ah = AOS_BIOS_FLAG;
	regs.h.al = cmd-3;
	regs.x.bx=0;
	regs.x.dx=0;
	regs.x.cx=size;

	int86(0x10, &regs, &regs);

}

void fopenVFile(int cmd,char *mode)
{
	pVFile[VFILE(cmd)]=getpminfo(cmd,&nVSize[VFILE(cmd)]);
	pVPos[VFILE(cmd)]=pVFile[VFILE(cmd)];
	if(*mode=='w')
	{
		*pVFile[VFILE(cmd)]=0;
		nVMode[VFILE(cmd)]=V_WRITE;
	}
	else
      nVMode[VFILE(cmd)]=V_READ;

}

char *fgetsVFile(char *buffer,int n,int cmd)
{
	char *pWork;
	char *pWork2;

	pWork2=pVPos[VFILE(cmd)];

	*buffer=0;

	if(!*pVPos[VFILE(cmd)])
		return NULL;
	pWork=strstr(pVPos[VFILE(cmd)],"\n");
	if(pWork)
	{
		*pWork=0;
		pWork++;
	}
	else
		pWork=pVPos[VFILE(cmd)]+strlen(pVPos[VFILE(cmd)]);


	pVPos[VFILE(cmd)]=pWork;
	strncpy(buffer,pWork2,n);
	return pWork2;
}


void fprintfVFile(int cmd,char *buffer,...)
{
   char locbuf[1024];
   va_list args;

   va_start(args,buffer);
   vsprintf(locbuf,buffer,args);
   va_end(args);

   if((strlen(pVFile[VFILE(cmd)])+strlen(locbuf))<8192)
	  strcat(pVFile[VFILE(cmd)],locbuf);
}

char *fputsVFile(char *buffer,int cmd)
{
	char *pWork;

	pWork=pVPos[VFILE(cmd)];
	strcpy(pVPos[VFILE(cmd)],buffer);
	pVPos[VFILE(cmd)]+=strlen(buffer);

	return pWork;
}


void setarcsvga(void)
{
	setati15KHz();
}


int AOSAlready(void)
{

	union REGS regs;

	regs.h.ah = AOS_BIOS_FLAG;
	regs.h.al = CHECK_BIOS;

	int86(0x10, &regs, &regs);
	if(regs.x.bx==24)
		return TRUE;
	return FALSE;
}
