#include "main.h"
#include "disp.h"
#include "launch.h"
#include "scrasm.h"
#include "screen.h"
#include "info.h"
#include "check.h"
#include "emu.h"
#include "glist.h"
#include "keyasm.h"
#include "mouse.h"
#include "sound.h"

// DANNY REGO
#include "lcdlib.h"

extern pBYTE pCharSet;
extern int autorunninggame;
static	int	 nCurDisk;
static	char szCurDir[512];
static WINSTRUCT	winrom;

int nStartDisk;
char szStartDir[512];

static	int	CheckPos;
static	int	bFirstCheck;
static	int	NoLines;
static	char *pIn;
static	char szAppIdents[][16]={
						"name","path","exe","ini",
						"writetoini","iniusesequal",
						"iniusesminus","singlegame",
						"filepattern","directories",
						"zipfiles","rompathid",
						"incabinetopts",
						"defaultoptions","configfile",
						"optionsasargs",
						"reprogramvga","gameprefix",
						"useextension","zippath",
						"singledir","needzipext",
						"redirect","commentchar",
                                                "backdrop","descfile",
						"screenshots","pcxdir",
						"sssuffix","suffixow",
						"clist1","clist2","clist3",
						"clist4","clist5","clist6",
						"clist7",
                  "update","virtualemu",
                  "pngdir","flyerdir","cabdir",
						"modexdelay","modexmode",
						"lowercase","remaplist","remaptype",
						"blocktext","lowlevelredir","readmefile",
                  "noremap","remapdelay",
                  "shift1","shift2","shift3","shift4","shift5","shift6",
                  "clonefile","mergedroms",
                  "supportsrot","rotleft","rotright","norot","rompath",
// DANNY REGO
                                                "lcdlogo","lcddir",

                  "svgaincabopts"};

/* EEA 08/26/00 Added "rompath" above */

void emudir(char *szVirtual)
{
	char	szCommand[1024];
//get a directory without the \ at the end
	if(szVirtual&&*szVirtual)
		godir(szVirtual);
	else
	{
		strcpy(szCommand,Emulators[CurEmu].szPath);
		godir(szCommand);
	}
}

void startupdir(void)
{
	int n;
	nStartDisk=getdisk();
	getcwd(szStartDir,512);
	checkpath(szStartDir);

}

void godir(char *szDir)
{
	static char	szTemp[512];
	char	*pWork;
    getdir();
//get rid of the last back slash
	if(szDir[strlen(szDir)-1]=='\\')
		szDir[strlen(szDir)-1]=0;
//do we need to change drives ??
	if(szDir[1]==':')
	{
//yep, skip past the drive letter and the :
		setdisk(toupper(szDir[0])-'A');
		pWork=&szDir[2];
		chdir(pWork);
	}
	else
	{
//nope
		chdir(szDir);
	}
}

void menudir()
{
//change back to our directory
	setdisk(nCurDisk);
	chdir(szCurDir);
}

void getdir(void)
{
 //get the current directory
	nCurDisk=getdisk();
	getcwd(szCurDir,512);
}

int addincabinetini()
{
	int	n;
	char *pWork;
	static char	szCommand[512];
	static char	buffer[1024];
	static char	szTemp[128];


   char *pCabOpts=Emulators[CurEmu].szInCabinetOpts;

   if(!InCabinet)
      return FALSE;
   if(*pCabOpts!='@')
      return FALSE;;

   for(n=0;n<getitemcount(pCabOpts,'%');n++)
	{
		pWork=buffer;
      getitem(pWork,pCabOpts,n,127,'%');
		if(*pWork=='@')
			pWork++;
//get the ident
		getitem(szTemp,pWork,0,127,',');
		safecopy(cfgDefValues[NoCfgValues].szIdent,szTemp,sizeof(cfgDefValues[NoCfgValues].szIdent));

//set the type
		cfgDefValues[NoCfgValues].nType=CFG_TYPE_SPECIAL;
//get the value
		getitem(szTemp,pWork,1,127,',');
		safecopy(cfgDefValues[NoCfgValues].szCommands,szTemp,sizeof(cfgDefValues[NoCfgValues].szCommands));
//set the defaults
		cfgDefValues[NoCfgValues].nValue=atoi(cfgDefValues[NoCfgValues].szCommands);
		cfgDefValues[NoCfgValues].bWritten=FALSE;
		cfgDefValues[NoCfgValues].nDefault=0;
		cfgDefValues[NoCfgValues].min=0;
		cfgDefValues[NoCfgValues].max=1;
		cfgDefValues[NoCfgValues].Emu=CurEmu;
		cfgDefValues[NoCfgValues].bFound=FALSE;
		cfgDefValues[NoCfgValues].nOffSet=0;

		NoCfgValues++;
	}

   if(NoCfgValues)
      return TRUE;
   else
      return FALSE;
}

int launchgame(int nCurPos,int nGames,int bjukebox)
{
/* EEA 08/26/00 Added this szFullPathName */
   char  szFullPathName[256];
   char  szWork[128];
	char	szDispName[64];
	char	szWork2[256];
	static	char szVirtPath[256];
	static	char buffer[1024];
	char	*pWork;
	int	nWidth;
	int	nSaveNo;
	int 	n,nCol,bFound,nNoDirs;

	static char	szCommand[512];
	static char szFilCom[256];
	static char szGameCom[256];
	static char	szTemp[512];
   static char szRemapList[512];
   static char GameName[256];
   char *pCabOpts;

   pCabOpts=Emulators[CurEmu].szInCabinetOpts;



	*szFilCom=0;


	if(!nGames)
	{
		seterror("No Games Found","");
		return FALSE;

	}
	if((pMameGames[nCurPos].Orientation&7)==4)
		return FALSE;

   strcpy(GameName,pMameGames[nCurPos].GameName);



   nWidth=18;
	strcpy(buffer,pMameGames[nCurPos].szDispName);
	pWork=strstr(buffer,":");
	n=0;
	if(pWork)
	{
		n=2;
		*pWork=0;
		pWork++;
		copylastn(pWork,szCommand,ScreenOrient.maxx-7);

		szCommand[ScreenOrient.maxx-7]=0;
		if(strlen(szCommand)>nWidth)
			nWidth=strlen(szCommand);
	}
	buffer[ScreenOrient.maxx-7]=0;
	if(strlen(buffer)>nWidth)
		nWidth=strlen(buffer);
	strcpy(szDispName,buffer);
	if(!noUseLastShot)
      getscreenshot(nCurPos,FALSE,TRUE,SSRun); // EEA Changed from !noAltSSRun
	fastback();

   if(!noShowRun)
		showrunwindow(szDispName,szCommand,nWidth,n);

   if(autorunninggame)
   {
      if(!noShowRun)
         flipscreen(FALSE);
   }
   else
      flipscreen(FALSE);


   setupremaplist(nCurPos,szRemapList);


//get the basic command
	if(Emulators[CurEmu].bVirtualEmu)
	{
//try to find which directory the game is in
//get the game's file name
      strcpy(szWork,GameName);
		pWork=Emulators[CurEmu].szPattern;
		while(*pWork)
		{
			if(*pWork=='.')
				break;
			pWork++;
		}
		strcat(szWork,pWork);
//then search the directories
		n=0;
		bFound=FALSE;
		nNoDirs=getitemcount(Emulators[CurEmu].szRomsDir,';');

		while(TRUE)
		{
//get the directory
			pWork=getitem(szWork2,Emulators[CurEmu].szRomsDir,n,255,';');

			strcpy(szVirtPath,pWork);
			sprintf(szWork2,"%s%s",szVirtPath,szWork);
			if(checkfile(szWork2))
			{
				bFound=TRUE;
				break;
			}

			n++;
			if(n>=nNoDirs)
				break;

		}

		if(bFound)
			emudir(szVirtPath);
		else
			emudir(NULL);

	}
	else
	{

		emudir(NULL);

//HACK
//see if exe is different
//and see if we need to set the centerX stuff
		strcpy(szWork,Emulators[CurEmu].szExe);
		for(n=0;n<MAX_CFGS;n++)
		{
			if(!strcmpi(cfgDefValues[n].szIdent,"exe"))
			{
				if(cfgDefValues[n].nValue!=cfgDefValues[n].min)
					sprintf(szWork,"%s.exe",pszTextValues[cfgDefValues[n].nValue]);
			}
			if(!noEasyCenter&&CurEmu == EMU_MAME)
			{
				if(!strcmpi(cfgDefValues[n].szIdent,"centerx"))
					cfgDefValues[n].nValue=nCenterX;
				if(!strcmpi(cfgDefValues[n].szIdent,"centery"))
					cfgDefValues[n].nValue=nCenterY;

			}
		}
	}
//END OF HACK
	if(!checkfile(szWork))
	{
		sprintf(buffer,"Emulator %s not found",Emulators[CurEmu].szEmuName);
		sprintf(szTemp,"FileName - %s",szWork);
		seterror(buffer,szTemp);
		menudir();
		return TRUE;
	}

   if(!bjukebox&&!autorunninggame)
      soundinterface(SOUND_GAME);
//write out the config file (if we need to)
//check if we're setting incabinet with INI file things
	nSaveNo=NoCfgValues;



   if(addincabinetini()||Emulators[CurEmu].nWriteToIni)
	{
      writeemucfg(TRUE,FALSE);
		setconfigfile(FALSE,CurEmu,buffer);
      sprintf(szFilCom,"%s%s!%s",COMMAND_FCOPY,buffer,"blah");
	}
	NoCfgValues=nSaveNo;
//add the name of the game to run
	if(*Emulators[CurEmu].szSingle||Emulators[CurEmu].bVirtualEmu)
	{
//single - no game name
		strcpy(buffer,szWork);
	}
	else
	{
//lower case
		if(Emulators[CurEmu].bLowerCase)
		{
         strlwr(GameName);
			strlwr(pMameGames[nCurPos].szExtension);
		}
/* EEA 08/26/00 Added this next section */
		if (*Emulators[CurEmu].szRomPath)
		{
			strcpy(szFullPathName, Emulators[CurEmu].szRomPath);
         strcat(szFullPathName, GameName);
		}
		else
		{
         strcpy(szFullPathName, GameName);
		}
/* Changed name from GameName to szFullPathName in code below */
		if(*Emulators[CurEmu].szGamePrefix)
      {
         sprintf(buffer,"%s %s %s",szWork,Emulators[CurEmu].szGamePrefix,szFullPathName);
      }
		else
      {
         sprintf(buffer,"%s %s",szWork,szFullPathName);

      }
/* EEA 08/26/00 End of section changes */

		if(Emulators[CurEmu].bExtension)
		{
			strcat(buffer,".");
			strcat(buffer,pMameGames[nCurPos].szExtension);
		}
//zip file extension ?
		if(Emulators[CurEmu].bNeedZipExtension&&((pMameGames[nCurPos].nGameType&GAME_TYPE_ZIP)==GAME_TYPE_ZIP))
		{
			strcat(buffer,".zip");
		}

	}
//add on the incabinet stuff

   if(InCabinet&&*pCabOpts!='@')
	{
		strcat(buffer," ");
      strcat(buffer,pCabOpts);
	}

//write out forced command line arguments
	for(n=0;n<NoCfgValues;n++)
	{
		if(cfgDefValues[n].nType==CFG_TYPE_CMD)
		{
			if(!cfgDefValues[n].nValue)
			{
//check for mame and record/playback
				if(CurEmu==EMU_MAME&&
					(!strcmpi(cfgDefValues[n].szIdent,"record")||!strcmpi(cfgDefValues[n].szIdent,"playback")))
               sprintf(szTemp," -%s %s",cfgDefValues[n].szIdent,GameName);
				else
					sprintf(szTemp," -%s",cfgDefValues[n].szIdent);
				strcat(buffer,szTemp);
         }
		}
	}



//add on the default options
	strcat(buffer," ");
	strcat(buffer,Emulators[CurEmu].szDefaultOpts);
	trimspaces(buffer);
//special case for MAME rotations
   if(Emulators[CurEmu].bSupportsRotation)
	{
		switch((pMameGames[nCurPos].Orientation&7))
		{
			case 1:
            strcat(buffer," ");
            strcat(buffer,Emulators[CurEmu].rotright);
				break;
			case 2:
            strcat(buffer," ");
            strcat(buffer,Emulators[CurEmu].rotleft);
				break;
			case 3:
            strcat(buffer," ");
            strcat(buffer,Emulators[CurEmu].norot);
				break;
		}
	}
//are we putting the options onto the command line ?
	if(Emulators[CurEmu].bOptionsAsArgs)
	{
//yep, read through them
		for(n=0;n<NoCfgValues;n++)
		{
			*szWork=0;
//is it simple stuff ?
			if(cfgDefValues[n].szCommands[0]=='@')
			{
//yep, just use what's there
				switch(cfgDefValues[n].nType)
				{
					case	0:	//numbers
						sprintf(szWork,"-%s %d",cfgDefValues[n].szIdent,cfgDefValues[n].nValue);
						break;
					case	1: //text
						sprintf(szWork,"-%s %s",cfgDefValues[n].szIdent,pszTextValues[cfgDefValues[n].nValue]);
						break;
					case 	2: //real
						sprintf(szWork,"-%s %d.00000",cfgDefValues[n].szIdent,cfgDefValues[n].nValue);
						break;

				}
			}
			else
			{
//nope, more complicated
//get the actual value as an offet into the command string
				getitem(szTemp,cfgDefValues[n].szCommands,cfgDefValues[n].nValue-cfgDefValues[n].min,127,'%');
				sprintf(szWork,"%s",szTemp);
			}
			pWork=trimspaces(szWork);
			if(*pWork)
			{
				strcat(buffer," ");
				strcat(buffer,pWork);
			}
		}
	}
   if(Emulators[CurEmu].bVirtualEmu)
      sprintf(szTemp,"%s\\%s",szVirtPath,buffer);
   else
      sprintf(szTemp,"%s%s",Emulators[CurEmu].szPath,buffer);

// DANNY REGO
displayLCDGameInfo(GameName);


   loginfo(1,"Running - %s",szTemp);
	if(!noShowCommand)
	{
		n=strlen(szTemp);
		pWork=szTemp;
		nCol=0;
		memset(screen,0,ScreenOrient.memsize);

		while(n>0)
		{
			strncpy(szWork,pWork,ScreenOrient.maxx);
			szWork[ScreenOrient.maxx-1]=0;
			dispstring(0,nCol,szWork,ForeColour,TRUE,0,0,DISP_FONT);
			n-=strlen(szWork);
			pWork+=strlen(szWork);
			nCol++;
		}
		flipscreen(FALSE);
      sounddelay(3);

	}


//redirection
	if(!Emulators[CurEmu].bNoRedirect)
	{
		if(Emulators[CurEmu].bLowLevelRedirect)
			strcat(buffer," > c:\\m.tmp");
		else
			strcat(buffer," > c:\\m$.tmp");
	}

   if(CurEmu==EMU_MAME)
      AllowVesa=TRUE;
   else
      AllowVesa=FALSE;
//call our BIOS
	callAOSBios(BLOCK_MODES,Emulators[CurEmu].bBlockText,0);

	callAOSBios(SET_VESA,AllowVesa,0);
   callAOSBios(MODEX_SETUP,Emulators[CurEmu].nModeXDelay,0);

//run emulator
	if(nLogging)
    {
        if(nLogging>0)
        {
            loginfo(0,">>Start Game<< Emu:%s Game:%s ::%s",
                                    Emulators[CurEmu].szEmuName,szDispName,getlogstamp(szWork));
            sprintf(szGameCom,"%sEmu:%s Game:%s",COMMAND_GAMENAME,Emulators[CurEmu].szEmuName,szDispName);
        }
        else
        {
            loginfo(-2,"S|%s|%s|%s",Emulators[CurEmu].szEmuName,szDispName,getlogstamp(szWork));
            sprintf(szGameCom,"%s|%s|%s",COMMAND_GAMENAME,Emulators[CurEmu].szEmuName,szDispName);
        }
    }



   runcommand(buffer,TRUE,TRUE,szFilCom,szGameCom,bjukebox,szRemapList);

	return TRUE;
}

void showrunwindow(char *szLine1,char *szLine2,int nWidth,int n)
{
	WINSTRUCT lwin;
   createwin(&lwin,2,2,nWidth+2,n+3,0,3);
   drawwindow(&lwin,-1,TRUE,FALSE,"Running");
   dispcentre(5,szLine1,ExtraColour,3,nWidth,TRUE,0,0,DISP_FONT);
	if(n)
      dispcentre(5+n,szLine2,ForeColour,3,nWidth,TRUE,0,0,DISP_FONT);
}


//strip string of odd chars
void stripcontrolchars(char *szIn)
{
	int i;
	for(i=0;i<strlen(szIn);i++)
	{
		if(szIn[i]<32||szIn[i]>126)
		{
			szIn[i]=0;
			break;
		}
	}
}

//check for/display a MAME error
int mameerror(char *szMameFPS)
{
	FILE	*fErr;
	char	*pWork;
	char	*pWork2;
	static char	szSave[512];
	int	bErr=FALSE;
	int	ret=TRUE;
	int	bWarning=FALSE;
	static char	szTemp[512];
	static char	szCommand[512];
	static char	buffer[1024];
//clear the FPS string
	*szMameFPS=0;
	if(CurEmu!=EMU_MAME)
		return ret;
	if(Emulators[CurEmu].bLowLevelRedirect)
		strcpy(szTemp,"c:\\m.tmp");
	else
		strcpy(szTemp,"c:\\m$.tmp");

//clear our critical error var
	if(Emulators[CurEmu].bNoRedirect)
		critclear();
//try to open the file
	*szMameFPS=0;

	fErr=fopen(szTemp,"rt");
//do we have a file ?
	if(fErr!=NULL)
	{
//yep, read in the first line
		if((pWork2=stripget(buffer,1023,fErr))!=NULL)
		{
			if(CurEmu==EMU_MAME)
			{
//check if it's just the FPS thing
				if((pWork=strstr(pWork2,FPS_TEXT))!=NULL)
				{
//it is, so no error
					fclose(fErr);
					stripcontrolchars(pWork);
					safecopy(szMameFPS,pWork,31);
					unlink(szTemp);
					return ret;
				}
			}
//it isn't - so errors (maybe)
			safecopy(szSave,pWork2,511);
			stripcontrolchars(szSave);
			*szCommand=0;
			tidyget(szCommand,511,fErr);
			if((pWork=strstr(szCommand,FPS_TEXT))!=NULL)
			{
//it is, so no error
				fclose(fErr);
				stripcontrolchars(pWork);
				safecopy(szMameFPS,pWork,31);
				unlink(szTemp);
				return ret;
			}

			stripcontrolchars(szCommand);

			if(strstr(szCommand,"NOT FOUND")||strstr(szSave,"NOT FOUND"))
			{
				strcpy(szSave,"Missing or incorrect ROMS");
				strcpy(szCommand,"Please Check ROMSET");
			}
//just check it isn't a warning
			if(!noHideWarnings)
			{
				fseek(fErr,0,SEEK_SET);
				while(TRUE)
				{
					if(!tidyget(buffer,1023,fErr))
						break;
					if(strstr(buffer,"WARNING"))
					{
						bWarning=TRUE;
						break;
					}
				}
			}

			if(!bWarning&&(CurEmu==EMU_MAME||bErr))
			{
//clear the run state - as it failed
            RunState=0;
            seterror(szSave,szCommand);
            loginfo(0,"ERROR Running Game - %s",szCommand);
				ret=FALSE;
			}
		}
		fclose(fErr);
      unlink(szTemp);
	}
	return ret;
}
void getFPS(char *szAct,char *szMame)
{
	char *pWork;
	*szAct=0;

	pWork=strstr(szMame,":");
	if(pWork)
	{
		pWork+=2;
		pWork[5]=0;
		strcpy(szAct,pWork);
	}
}


void endexefile(void)
{
   fopenRM(SET_COMMANDS);
   fprintfRM("::%s::\n",COMMAND_HEADER);
   fprintfRM("$END$\n");
   fcloseRM();

}

int runcommand(char *szCom,int bRets,int bVirtual,char *szFilCom,char *szGameCom,int bjukebox,char *szRemap)
{
   int ret,i;
   int nag;

   static int sixbuttons[]={K_B1,K_B2,K_B3,K_2_B1,K_2_B2,K_2_B3};

   if(CurEmu==EMU_MAME)
      nag=Nag;
   else
      nag=1;


	if(bVirtual)
	{
      fopenRM(SET_COMMANDS);
      fprintfRM("::%s::\n",COMMAND_HEADER);
      fprintfRM("$rets$%d\n",bRets);
      if(szFilCom&&*szFilCom)
         fprintfRM("%s\n",szFilCom);
      if(szGameCom&&*szGameCom)
         fprintfRM("%s\n",szGameCom);

      if(bjukebox)
         fprintfRM("%s\n",COMMAND_JUKEBOX);
//remap shifts, only active if on
      if(!Emulators[CurEmu].bNoRemap&&(!noShiftKeys||!noStart12Esc))
		{
         if(szRemap&&*szRemap&&!noShiftKeys)
         {
            fprintfRM("%s%d}%d}%d}%d}%d}%s\n",COMMAND_REMAP,!noStart12Esc,Emulators[CurEmu].nRemapType,
                                             Emulators[CurEmu].nDelLen,ShiftKey,(int)scancodes[K_COIN1],szRemap);
         }
			else
         {
            if(!noStart12Esc||Emulators[CurEmu].cShiftChar[0])
               fprintfRM("%s%d}%d}%d}%d}%d}%s\n",COMMAND_REMAP,!noStart12Esc,Emulators[CurEmu].nRemapType,
                     Emulators[CurEmu].nDelLen,ShiftKey,(int)scancodes[K_COIN1],NO_REMAPS);
         }

         fprintfRM("%s%d\n",COMMAND_NAG,nag);


         if(!noShiftKeys&&Emulators[CurEmu].cShiftChar[0])
         {
//write out the command
            fprintfRM("%s",COMMAND_SHIFTS);
//the scancodes for the 6 buttons
            for(i=0;i<6;i++)
               fprintfRM("%d,",(int)scancodes[sixbuttons[i]]);
            fprintfRM("}");
//and the scancodes for the 6 shift functions
            for(i=0;i<6;i++)
               fprintfRM("%d,",(int)Emulators[CurEmu].cShiftChar[i]);
            fprintfRM("\n");

         }
      }

      fprintfRM("$com$%s\n",szCom);

      fcloseRM();
		ret=1;
	}
	else
	{
		putback();
		if(bRets)
		{
			clearkbuff();
			stuffrets();
		}

		ret=system(szCom);
		clearkbuff();

		initkey();
		replace();
	}
	return ret;
}
void checkroms(char *szName,int *CheckState)
{
	FILE		*fIn;
	char		*pWork;
	int lInSize;
	int lOutSize;
	int lLen;
	int bListRoms;
	int bCheckSamps;
	int bListSamps;
	char buffer[512];
	int	smaxx;

	smaxx=ScreenOrient.maxx;
	if(smaxx>49)
		smaxx=49;
	CheckPos=0;
	bFirstCheck=TRUE;
	NoLines=0;

	lInSize=65535L;
	lOutSize=0;

	emudir(NULL);

	unlink("c:\\x.tmp");


	bListRoms=FALSE;
	bCheckSamps=TRUE;
	bListSamps=TRUE;
	sprintf(buffer,"%s -verifyroms %s >>c:\\x.tmp",Emulators[CurEmu].szExe,szName);
   clearsoundinterface();
   runcommand(buffer,FALSE,FALSE,NULL,NULL,FALSE,NULL);

//check for romset not found

	fIn=fopen("c:\\x.tmp","rt");
	if(!fIn)
	{
		myfree(pIn);
		return;
	}
	tidyget(buffer,256,fIn);
	if(strstr(buffer,"not found")||strstr(buffer,"NOT FOUND"))
	{
		fclose(fIn);
		if(strstr(buffer,"not found"))
		{
			fIn=fopen("c:\\x.tmp","wt");
			sprintf(buffer,"ROMS for %s not found!\n",szName);
			fputs(buffer,fIn);
		}
		bListRoms=TRUE;

	}
	else
	{
		if(strstr(buffer,"not supported"))
		{
			fclose(fIn);
			fIn=fopen("c:\\x.tmp","wt");
			sprintf(buffer,"%s not supported!\n",szName);
			fputs(buffer,fIn);
			bCheckSamps=FALSE;
			bListSamps=FALSE;
		}
	}
	fclose(fIn);

	fIn=fopen("c:\\x.tmp","at");
	checksep(fIn);
	if(bCheckSamps)
	{
		fputs("Samples:\n",fIn);
		fclose(fIn);

		sprintf(buffer,"%s -verifysamples %s >c:\\y.tmp",Emulators[CurEmu].szExe,szName);
		system(buffer);
		fIn=fopen("c:\\y.tmp","rt");
		tidyget(buffer,256,fIn);

		fclose(fIn);
		fIn=fopen("c:\\x.tmp","at");

		if(strstr(buffer,"not supported"))
		{
			sprintf(buffer,"%s Doesn't use Samples",szName);
			bListSamps=FALSE;
		}
		if(strstr(buffer,"OK"))
			bListSamps=FALSE;
		strcat(buffer,"\n");
		fputs(buffer,fIn);

	}
	fclose(fIn);

	if(bListRoms)
	{
		fIn=fopen("c:\\x.tmp","at");
		checksep(fIn);
		fclose(fIn);

		sprintf(buffer,"%s -listroms %s >>c:\\x.tmp",Emulators[CurEmu].szExe,szName);
        runcommand(buffer,FALSE,FALSE,NULL,NULL,FALSE,NULL);

	}
	if(bListSamps)
	{
		fIn=fopen("c:\\x.tmp","at");
		checksep(fIn);
		fputs("Sample List:\n",fIn);
		fclose(fIn);
		sprintf(buffer,"%s -listsamples %s >>c:\\x.tmp",Emulators[CurEmu].szExe,szName);
        runcommand(buffer,FALSE,FALSE,NULL,NULL,FALSE,NULL);
		fIn=fopen("c:\\x.tmp","at");
		checksep(fIn);
		fclose(fIn);
	}
	while(TRUE)
	{
		pIn=myalloc(lInSize);
		if(pIn)
			break;
		lInSize-=5;
		if(lInSize==0)
			break;
	}
	if(!pIn)
		return;
	pWork=pIn;

	fIn=fopen("c:\\x.tmp","rt");
	if(fIn)
	{
		while(TRUE)
		{
			if(!fgets(buffer,256,fIn))
				break;
			stripcontrolchars(buffer);
			strcat(buffer,"^");
			lLen=strlen(buffer);
			if((lOutSize+lLen)>=lInSize)
				break;
			strcpy(pWork,buffer);
			lOutSize+=lLen;
			pWork+=(unsigned int)lLen;
		}
		fclose(fIn);

		NoLines=displong(pIn,2,smaxx-2,ScreenOrient.maxy-4,1,0,TRUE,TRUE);
		NoLines=0;

      *CheckState=MENU_STATE_CHECK;
	}
	menudir();
   initsoundinterface();
}

void checksep(FILE *fIn)
{
	fputs("-----\n",fIn);
}

void checkresults(char *szName)
{
	char	buffer[64];
	int	nReal;
	int	smaxx;
	nReal=NoLines-(ScreenOrient.maxy-5);

	smaxx=ScreenOrient.maxx;
	if(smaxx>49)
		smaxx=49;


	sprintf(buffer,"%s ROM Check",szName);

    createwin(&winrom,0,0,smaxx,ScreenOrient.maxy,0,0);
	winrom.winproc=infoproc;

	winrom.bHasScrollBar=FALSE;
	pStdPos=NULL;
	pStdMax=NULL;

	drawwindow(&winrom,1,TRUE,bFirstCheck,buffer);
	displong(pIn,2,smaxx-2,ScreenOrient.maxy-4,1,CheckPos,FALSE,TRUE);
	if(NoLines>ScreenOrient.maxy)
	{
      winrom.scrollpos=drawscrollbar(&winrom,&CheckPos,nReal,winrom.control);
		winrom.bHasScrollBar=TRUE;
	}
	registerwindow(&winrom);

	dispcentre(ScreenOrient.maxy-2,"Start 2 to Close",14,2,smaxx-4,TRUE,0,2,DISP_FONT);
	bFirstCheck=FALSE;
}

void movecheckcursor(void)
{
	int	nReal;

	nReal=NoLines-(ScreenOrient.maxy-4);
   movement(&CheckPos,(ScreenOrient.maxy-4));

	if(CheckPos<0)
		CheckPos=0;
	if(nReal>0)
	{
		if(CheckPos>nReal)
			CheckPos=nReal;
	}
}

void quitcheck()
{
	if(pIn)
		myfree(pIn);
	pIn=NULL;
}

int getemulators(pEMULATOR Emus)
{
	int	n,NoEmus,i;
	int	nRealNo;
	size_t	lenfound;
	int	nindex=0;
	FILE	*fApp;
	char	*pWork;
	static char	szWork[256];
	pGETFILE	pEmuFiles;
	static char	szTemp[256];
	static char	buffer[1024];

   char szFile[256];


	pEmuFiles=myalloc(FILESIZE(MAX_EMUS));

//set the default up (MAME)
	if(!setmameemu(Emus))
		return -2;

//now read in any .app files
	NoEmus=0;
	getallfiles(pEmuFiles,&NoEmus,"*.app",FA_ARCH,0,MAX_EMUS);
	qsort((void *)pEmuFiles,NoEmus,sizeof(GETFILE),sort_function);
	nRealNo=1;

	for(n=0;n<NoEmus&&n<MAX_EMUS;n++)
	{
		sprintf(szTemp,"%s.app",pEmuFiles[n].FileName);
		fApp=fopen(szTemp,"rt");
      strcpy(szFile,szTemp);
		if(fApp!=NULL)
		{

/* EEA 08/26/00 Added all of these to safely initialize strings (otherwise we are
   assuming that the strings have 0 in the first array position) */
			*Emus[nRealNo].szEmuName=0;
			*Emus[nRealNo].szPath=0;
			*Emus[nRealNo].szExe=0;
			*Emus[nRealNo].szInfoExe=0;
			*Emus[nRealNo].szIni=0;
			*Emus[nRealNo].szSingle=0;
			*Emus[nRealNo].szPattern=0;
			*Emus[nRealNo].szRomsDir=0;
			*Emus[nRealNo].szInCabinetOpts=0;
			*Emus[nRealNo].szDefaultOpts=0;
			*Emus[nRealNo].szConfigFile=0;
			*Emus[nRealNo].szGamePrefix=0;
			*Emus[nRealNo].szRomPath=0;
			*Emus[nRealNo].szSinglePath=0;
			*Emus[nRealNo].szZipPath=0;
			*Emus[nRealNo].szPCXPath=0;
			*Emus[nRealNo].szPNGPath=0;
			*Emus[nRealNo].szFlyerPath=0;
			*Emus[nRealNo].szCabPath=0;
			*Emus[nRealNo].szPCXSuffix=0;
			*Emus[nRealNo].szCommentChar=0;
			*Emus[nRealNo].szBackdrop=0;
                        *Emus[nRealNo].szLCDLogo=0;
                        *Emus[nRealNo].szLCDPath=0;
			*Emus[nRealNo].szTableName=0;
			*Emus[nRealNo].szUpdateExe=0;
//         *Emus[nRealNo].szRemapList=0;
         *Emus[nRealNo].szReadMe=0;
         *Emus[nRealNo].szCloneFile=0;

// EEA			*Emus[nRealNo].szPNGPath=0;
			Emus[nRealNo].nModeXDelay=0;
			Emus[nRealNo].bLowerCase=FALSE;
			Emus[nRealNo].bAllEmu=FALSE;
// EEA			*Emus[nRealNo].szRemapList=0;
			Emus[nRealNo].nRemapType=0;
         Emus[nRealNo].bBlockText=1;
			Emus[nRealNo].bLowLevelRedirect=0;
			Emus[nRealNo].bNoRemap=0;
			Emus[nRealNo].nDelLen=1;
// EEA 			*Emus[nRealNo].szReadMe=0;
         Emus[nRealNo].bSupportsMerged=0;
         Emus[nRealNo].bSupportsRotation=0;
         memset(Emus[nRealNo].cShiftChar,0,sizeof(int)*6);
         strcpy(Emus[nRealNo].szCustomList[0],"Standard"); 


			while(tidyget(buffer,1023,fApp)!=NULL)
			{
//check for remarks
				if(strstr(buffer,"#")!=buffer)
				{
					lenfound=0;
//not a remark, so see what we've got
					for(i=0;i<(sizeof(szAppIdents)/16);i++)
					{
//matches ident ?
						if(strstr(buffer,szAppIdents[i]))
						{
//longest string so far ?
							if(strlen(szAppIdents[i])>lenfound)
							{
//yep, save it
								lenfound=strlen(szAppIdents[i]);
								nindex=i;
							}
						}
					}
					if(lenfound)
					{
//get the value
						getitem(szTemp,buffer,1,128,'=');
						pWork=trimspaces(szTemp);

						switch(nindex)
						{
							case	APP_NAME:
								GETSTRING(Emus[nRealNo].szEmuName);
								break;
							case	APP_PATH:
								checkpath(pWork);
								GETSTRING(Emus[nRealNo].szPath);
								break;
							case 	APP_EXE:
								GETSTRING(Emus[nRealNo].szExe);
								break;
							case  APP_INI:
								GETSTRING(Emus[nRealNo].szIni);
								break;
							case 	APP_WRITEINI:
								GETNO(Emus[nRealNo].nWriteToIni);
								break;
							case  APP_USEEQUAL:
								GETNO(Emus[nRealNo].bIniUsesEqual);
								break;
							case 	APP_USEMINUS:
								GETNO(Emus[nRealNo].bIniUsesMinus);
								break;
							case	APP_SINGLE:
								GETSTRING(Emus[nRealNo].szSingle);
								break;
							case	APP_FILEPAT:
								GETSTRING(Emus[nRealNo].szPattern);
								break;
							case	APP_DIRECT:
								GETNO(Emus[nRealNo].bDirectories);
								break;
							case	APP_ZIPFILES:
								GETNO(Emus[nRealNo].bZipFiles);
								break;
							case	APP_ROMIDENT:
								GETSTRING(szWork);
								readinival(szWork,Emus[nRealNo].szRomsDir,255,nRealNo);
                        if(!*Emus[nRealNo].szRomsDir)
                           strcpy(Emus[nRealNo].szRomsDir,"roms");
								break;
							case	APP_CABOPTS:
								GETSTRING(Emus[nRealNo].szInCabinetOpts);
								break;
							case	APP_DEFOPTS:
								GETSTRING(Emus[nRealNo].szDefaultOpts);
								break;
							case	APP_CONFIG:
								GETSTRING(Emus[nRealNo].szConfigFile);
								break;
							case	APP_OPTIONARGS:
								GETNO(Emus[nRealNo].bOptionsAsArgs);
								break;
							case	APP_REPVGA:
								GETNO(Emus[nRealNo].bReprogramVGA);
								break;
							case	APP_GAMEPREFIX:
								GETSTRING(Emus[nRealNo].szGamePrefix);
								break;
							case	APP_USEEXT:
								GETNO(Emus[nRealNo].bExtension);
								break;
							case	APP_ZIPPATH:
								GETSTRING(szWork);
								readinival(szWork,Emus[nRealNo].szZipPath,127,nRealNo);
								break;
							case	APP_SINGLEDIR:
								GETSTRING(szWork);
								readinival(szWork,Emus[nRealNo].szSinglePath,127,nRealNo);

								break;
							case	APP_NEEDZIPEXT:
								GETNO(Emus[nRealNo].bNeedZipExtension);
								break;
							case	APP_REDIRECT:

								GETNO(Emus[nRealNo].bNoRedirect);
								Emus[nRealNo].bNoRedirect=!Emus[nRealNo].bNoRedirect;
								break;
							case	APP_COMMENTCHAR:
								GETSTRING(Emus[nRealNo].szCommentChar);
								break;
							case	APP_BACKDROP:
								GETSTRING(Emus[nRealNo].szBackdrop);
								break;
// DANNY REGO
                                                        case    APP_LCDLOGO:
                                                                GETSTRING(Emus[nRealNo].szLCDLogo);
								break;
                                                        case    APP_LCDDIR:
                                                                GETSTRING(Emus[nRealNo].szLCDPath);
								break;

							case	APP_DESCFILE:
								GETSTRING(Emus[nRealNo].szTableName);
								break;
							case	APP_SCREENSHOTS:
								GETNO(Emus[nRealNo].bScreenShots);
								break;
							case	APP_PCXDIR:
								GETSTRING(szWork);
								readinival(szWork,Emus[nRealNo].szPCXPath,127,nRealNo);
								break;
							case	APP_PCXSUFFIX:
								GETSTRING(Emus[nRealNo].szPCXSuffix);
								break;
							case	APP_PCXSUFFIXOW:
								GETNO(Emus[nRealNo].bSuffixOW);
								break;
                     case APP_CUSTOM1:
                     case APP_CUSTOM2:
                     case APP_CUSTOM3:
                     case APP_CUSTOM4:
                     case APP_CUSTOM5:
                     case APP_CUSTOM6:
                     case APP_CUSTOM7:
								GETSTRING(Emus[nRealNo].szCustomList[(nindex-APP_CUSTOM1)+1]);
								break;
                     case APP_UPDATE:
								GETSTRING(Emus[nRealNo].szUpdateExe);
								break;
                     case APP_VIRTUAL:
								GETNO(Emus[nRealNo].bVirtualEmu);
								break;
                     case APP_PNGDIR:
								GETSTRING(szWork);
                        readinival(szWork,Emus[nRealNo].szPNGPath,127,nRealNo);
								break;
                     case APP_FLYERDIR:
								GETSTRING(szWork);
                        readinival(szWork,Emus[nRealNo].szFlyerPath,127,nRealNo);
								break;
                     case APP_CABDIR:
								GETSTRING(szWork);
                        readinival(szWork,Emus[nRealNo].szCabPath,127,nRealNo);
								break;
                     case APP_MODEXDELAY:
								GETNO(Emus[nRealNo].nModeXDelay);
								break;
                     case APP_LOWERCASE:
								GETNO(Emus[nRealNo].bLowerCase);
								break;
                     case APP_REMAPLIST:
								GETSTRING(Emus[nRealNo].szRemapList);
								break;
                     case APP_REMAPTYPE:
								GETNO(Emus[nRealNo].nRemapType);
								break;
                     case APP_BLOCKTEXT:
								GETNO(Emus[nRealNo].bBlockText);
								break;
                     case APP_LLREDIRECT:
								GETNO(Emus[nRealNo].bLowLevelRedirect);
								break;
                     case APP_README:
								GETSTRING(Emus[nRealNo].szReadMe);
								break;
                     case APP_NOREMAP:
								GETNO(Emus[nRealNo].bNoRemap);
								break;
							case	APP_DELLEN:
								GETNO(Emus[nRealNo].nDelLen);
                        break;
                     case  APP_SHIFT1:
                     case  APP_SHIFT2:
                     case  APP_SHIFT3:
                     case  APP_SHIFT4:
                     case  APP_SHIFT5:
                     case  APP_SHIFT6:
                        GETNO(Emus[nRealNo].cShiftChar[nindex-APP_SHIFT1]);
								break;
                     case  APP_CLONE_FILE:
                        GETSTRING(Emus[nRealNo].szCloneFile);
                        break;
                     case  APP_SUPPORTS_MERGE:
                        GETNO(Emus[nRealNo].bSupportsMerged);
                        break;
                     case  APP_SUPPORTS_ROT:
                        GETNO(Emus[nRealNo].bSupportsRotation);
                        break;
                     case  APP_ROT_LEFT:
                        GETSTRING(Emus[nRealNo].rotleft);
                        break;
                     case  APP_ROT_RIGHT:
                        GETSTRING(Emus[nRealNo].rotright);
                        break;
                     case  APP_NO_ROT:
                        GETSTRING(Emus[nRealNo].norot);
                        break;
/* EEA 08/26/00 Added this */
                     case APP_ROMPATH:
                        checkpath(pWork);
                        GETSTRING(Emus[nRealNo].szRomPath);
                        break;
						}
					}
				}
			}
			fclose(fApp);
         nRealNo++;


		}
	}
	myfree(pEmuFiles);
	return nRealNo;
}

void changeemu(int NewEmu)
{
	WINSTRUCT chgwin;
   int nSaveCfgs;
	if(NewEmu<0)
      NewEmu=nNoEmulators-1;
	if(NewEmu>=nNoEmulators)
      NewEmu=0;
   createwin(&chgwin,2,8,20,8,0,0);

	drawwindow(&chgwin,1,TRUE,FALSE,"Change Emu");
	dispcentre(11,"Changing To:",15,3,18,FALSE,0,0,DISP_FONT);
	dispcentre(13,Emulators[NewEmu].szEmuName,ExtraColour,3,18,TRUE,0,0,DISP_FONT);
	flipscreen(FALSE);



//write out the game configs
   writegamelist(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]);
//and the emu settings
   writeemucfg(FALSE,TRUE);


	CurEmu=NewEmu;

	//get the config default values
	getdefcfgvals();

	readcfgvals();
	if(NoCfgValues>MAX_CFGS)
		NoCfgValues=MAX_CFGS;


   setscreenorient();

   createlist(&NoGames,ROTATION,nLastGame[CurEmu]);
   setuprandomlist(NoGames);
	precalcfont();
	setbackdrop();

// DANNY REGO
   displayLCDLogo();

   nLastGame[CurEmu]=-1;
}

int setmameemu(pEMULATOR Emus)
{
	int	n;
	static	char	szWork[8];
	static char	szTemp[512];
	strcpy(Emus[EMU_MAME].szEmuName,"MAME");
	checkpath(Emus[EMU_MAME].szPath);

	Emus[EMU_MAME].bAllEmu=FALSE;



	strcpy(Emus[EMU_MAME].szIni,"mame.cfg");
	*Emus[EMU_MAME].szSingle=0;
	*Emus[EMU_MAME].szPattern=0;
//set right monitor mode
	switch(InCabinet)
	{
      case ARCADE_MODE:
         strcpy(Emus[EMU_MAME].szInCabinetOpts,szMonOptions[0]);
			break;
      case PAL_MODE:
         strcpy(Emus[EMU_MAME].szInCabinetOpts,szMonOptions[1]);
			break;
      default:
         *Emus[EMU_MAME].szInCabinetOpts=0;
	}

	*Emus[EMU_MAME].szDefaultOpts=0;
	strcpy(Emus[EMU_MAME].szConfigFile,"mame.dat");
	*Emus[EMU_MAME].szGamePrefix=0;
/* EEA 08/26/00 Added this szRomPath initialization */
	*Emus[EMU_MAME].szRomPath=0;
	Emus[EMU_MAME].bExtension=0;
	*Emus[EMU_MAME].szSinglePath=0;
	*Emus[EMU_MAME].szCommentChar=0;
	Emus[EMU_MAME].nWriteToIni=1;
	Emus[EMU_MAME].bIniUsesEqual=TRUE;
	Emus[EMU_MAME].bIniUsesMinus=FALSE;
	Emus[EMU_MAME].bDirectories=TRUE;
	Emus[EMU_MAME].bZipFiles=TRUE;
	Emus[EMU_MAME].bOptionsAsArgs=FALSE;
   Emus[EMU_MAME].bBlockText=TRUE;
	Emus[EMU_MAME].bReprogramVGA=FALSE;
	Emus[EMU_MAME].bNeedZipExtension=FALSE;
	Emus[EMU_MAME].bLowLevelRedirect=1;
	Emus[EMU_MAME].bVirtualEmu=FALSE;
	Emus[EMU_MAME].nModeXDelay=0;
	Emus[EMU_MAME].bLowerCase=FALSE;
//   *Emus[EMU_MAME].szRemapList=0;
   Emus[EMU_MAME].bSupportsMerged=1;
   Emus[EMU_MAME].bSupportsRotation=1;
   strcpy(Emus[EMU_MAME].rotleft,"-rol");
   strcpy(Emus[EMU_MAME].rotright,"-ror");
   strcpy(Emus[EMU_MAME].norot,"-norotate");
	Emus[EMU_MAME].nRemapType=1;
	Emus[EMU_MAME].bNoRemap=FALSE;
	Emus[EMU_MAME].nDelLen=1;
	strcpy(Emus[EMU_MAME].szReadMe,"readme.txt");

	if(!readinival("rompath",szTemp,255,EMU_MAME))
		strcpy(szTemp,".;roms");

	safecopy(Emus[EMU_MAME].szRomsDir,szTemp,255);
	*Emus[EMU_MAME].szZipPath=0;
	Emus[EMU_MAME].bScreenShots=TRUE;
	Emus[EMU_MAME].bSuffixOW=FALSE;
	*Emus[EMU_MAME].szPCXSuffix=0;

	if(!readinival("pcx",szTemp,128,EMU_MAME))
		strcpy(szTemp,"pcx");
	safecopy(Emus[EMU_MAME].szPCXPath,szTemp,127);

	if(!readinival("snap",szTemp,128,EMU_MAME))
		strcpy(szTemp,"snap");
	safecopy(Emus[EMU_MAME].szPNGPath,szTemp,127);

	if(readinival("flyers",szTemp,64,EMU_MAME))         // EEA Changed from altss
      safecopy(Emus[EMU_MAME].szFlyerPath,szTemp,64);
	else
      strcpy(Emus[EMU_MAME].szFlyerPath,"flyers");


	if(readinival("cabinets",szTemp,64,EMU_MAME))       // EEA Added this
		safecopy(Emus[EMU_MAME].szCabPath,szTemp,64); // EEA
	else								    // EEA
        strcpy(Emus[EMU_MAME].szCabPath,"cabinets");

	strcpy(Emus[EMU_MAME].szCustomList[0],"Macgaiver");

	return TRUE;

}


void infoproc(int Message,int Data1,int Data2,void *pData)
{
	pWINSTRUCT	pWinStruct;
	int	nsel,nfarright,nbotright;
	winrom.control=0;

	if(nMouseType!=STANDARD_MOUSE)
		return;

	pWinStruct=(pWINSTRUCT)pData;


   switch(ScreenOrient.Orientation)
	{
		case 1:
		case 2:
			nfarright=pWinStruct->yoff+(pWinStruct->xbotright*pWinStruct->xmul);
			nbotright=(pWinStruct->xoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);
			break;
		default:
			nfarright=pWinStruct->xoff+(pWinStruct->xbotright*pWinStruct->xmul);
         nbotright=(pWinStruct->yoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);
   }

	nsel=Data2-pWinStruct->clienty;
	winrom.clienty=pWinStruct->clienty;

	switch(Message)
	{
		case WM_LUP:
			if(upokay())
			{
//see if it's on our exit box
				if(pWinStruct->onclose)
					keys[K_START2]=1;
			}
		case WM_LDOWN:
			handlescroll(Data1,nfarright,nbotright,&winrom,nsel,16,Message);
			break;
	}
}

void setupremaplist(int nCurPos,char *szRemapList)
{
    char szTemp[512];
    char buffer[1024];
    char *pwork;
    FILE *frmp;
//setup default
    strcpy(szRemapList,Emulators[CurEmu].szRemapList);
//try to find the file
    sprintf(szTemp,"%s\\%s.rmp",Emulators[CurEmu].szEmuName,pMameGames[nCurPos].GameName);

    if(checkfile(szTemp))
    {
//now get the remap list from it
        frmp=fopen(szTemp,"rt");
        if(frmp)
        {

            while(tidyget(buffer,1023,frmp)!=NULL)
            {
                if(*buffer!='#')
                {
                    pwork=strstr(buffer,"remaplis");
                    if(pwork)
                    {
                        pwork=strstr(pwork,"=");
                        if(pwork)
                        {
                            pwork++;
                            pwork=trimspaces(pwork);
                            strcpy(szRemapList,pwork);
                            break;
                        }
                    }
                }
            }
            fclose(frmp);
        }
    }
}
